//------------------------------------------------------------------------------
//
//  xil_8b10b_dec.v : xilinx 8b10b decode module
//
//  LICENSE : "as-is"
//  TakeshiNagashima(T.NG) caramelgate@gmail.com
//------------------------------------------------------------------------------
//  2009/mar/09 release 0.0  8b10b decode
//      /apr/24 release 0.0a rename
//
//------------------------------------------------------------------------------

module xil_8b10b_dec(
	input	[9:0]	dec_in,				// in    [dec] [9:0]
	output	[7:0]	dec_out,			// out   [dec] [7:0] data
	output			dec_k,				// out   [dec] k
	output			dec_err,			// out   [dec] err

	input			rst_n,				// in    [dec] 
	input			clk					// in    [dec] 
);

//--------------------------------------------------------------
//	override parameter

//--------------------------------------------------------------
//	local parameter

	localparam k280=9'b1_0001_1100;
	localparam k281=9'b1_0011_1100;
	localparam k282=9'b1_0101_1100;
	localparam k283=9'b1_0111_1100;
	localparam k284=9'b1_1001_1100;
	localparam k285=9'b1_1011_1100;
	localparam k286=9'b1_1101_1100;
	localparam k287=9'b1_1111_1100;
	localparam k237=9'b1_1111_0111;
	localparam k277=9'b1_1111_1011;
	localparam k297=9'b1_1111_1101;
	localparam k307=9'b1_1111_1111;

//--------------------------------------------------------------
//	signal

	reg		[9:0] dec_r;

	wire	dec_k_w;
	wire	[11:0] dec_out_w;
	wire	[9:0] dec_w;

	wire	code_k;
	wire	[7:0] code;

//--------------------------------------------------------------
//	design

	assign dec_k=dec_r[8];
	assign dec_out[7:0]=dec_r[7:0];

	always @(posedge clk or negedge rst_n)
	begin
		if (rst_n==1'b0)
			begin
				dec_r[9:0] <= 10'b0;
			end
		else
			begin
				dec_r[9:0] <= dec_w[9:0];
			end
	end

	assign dec_w[9:0]={1'b0,code_k,code[7:0]};

	wire	c_err;
	wire	d_err;

	assign dec_err=c_err | d_err;

DECODE_8B10B_V7_1 dec_8b10b(
	.CLK(clk),
	.DIN(dec_in[9:0]),
	.DOUT(code[7:0]),
	.KOUT(code_k),

	.CE(1'b1),
	.CE_B(1'b0),
	.CLK_B(1'b0),
	.DIN_B(10'b0),
	.DISP_IN(1'b0),
	.DISP_IN_B(1'b0),
	.SINIT(!rst_n),
	.SINIT_B(1'b1),
	.CODE_ERR(c_err),
	.CODE_ERR_B(),
	.DISP_ERR(d_err),
	.DISP_ERR_B(),
	.DOUT_B(),
	.KOUT_B(),
	.ND(),
	.ND_B(),
	.RUN_DISP(),
	.RUN_DISP_B(),
	.SYM_DISP(),
	.SYM_DISP_B()
);

endmodule


